// msgrepoitem.cpp
// Copyright (C) 2007-2009 Andrew Munkres
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

#include <QHeaderView>

#include "msgrepoitem.h"

#include "koeurlconfig.h" // Autogenerated by kconfig_compiler

#include "msgrepoitem.moc" // This must be here for moc to be run.

MsgRepoItem::MsgRepoItem(QTreeWidget *lv, QDomDocument &all_config,
                         MsgRepo *repo, TopPane *summary_view):
  QTreeWidgetItem(lv, QStringList(repo->name())),
  m_config(repo->createConfig(all_config)),
  m_repo(repo),
  m_summary_view(summary_view)
{
  // This constructor is used when creating a repository that isn't already
  // in the configuration file. It appends it to the end of the list of
  // repositories.
  all_config.documentElement().appendChild(m_config);
  constructorCommon();
}

MsgRepoItem::MsgRepoItem(QTreeWidget *lv, MsgRepoItem *insert_after,
                         MsgRepo *repo, TopPane *summary_view):
  QTreeWidgetItem(lv, insert_after),
  m_config(repo->createConfig(insert_after->m_config.ownerDocument())),
  m_repo(repo),
  m_summary_view(summary_view)
{
  // This constructor is used when creating a repository that isn't already
  // in the configuration file. It inserts it into the list after a
  // specified already-existing repository.
  setText(0, repo->name());
  insert_after->m_config.parentNode().insertAfter(m_config,
                                                  insert_after->m_config);
  constructorCommon();
}

MsgRepoItem::MsgRepoItem(QTreeWidget *lv, const QDomElement &saved_config,
                         MsgRepo *repo, TopPane *summary_view):
  QTreeWidgetItem(lv, QStringList(repo->name())),
  m_config(saved_config),
  m_repo(repo),
  m_summary_view(summary_view)
{
  // This constructor is used when loading the config file, so it does not
  // modify the DOM tree.
  constructorCommon();
}

void MsgRepoItem::constructorCommon()
{
  connect(m_repo, SIGNAL(readyToShow()), this, SLOT(showSummary()));
  connect(m_repo, SIGNAL(readyToShowMessage()),
          m_summary_view->parent()->parent()->parent(), SLOT(showMessage()));
}

MsgRepoItem::~MsgRepoItem()
{
  m_config.parentNode().removeChild(m_config);
  delete m_repo;
}

void MsgRepoItem::prepareToShow(KMenu *menu, KActionCollection *actions)
{
  m_repo->beginActivatingRepo(menu, actions);
}

void MsgRepoItem::prepareToShowMessage(SummaryItem *msg_item)
{
  m_repo->beginActivatingMessage(msg_item->getID());
}

void MsgRepoItem::showSummary()
{
  // TODO: It would make more sense for this method to belong to a different
  // class, maybe ProgramWindow.
  
  // maybe this QMap should be a class member; but of what class?
  QMap<QString, SummaryItem *> msgs_by_id;
  QMap<QString, SummaryItem *>::iterator not_found(msgs_by_id.end()),
    entry;
  SummaryItem *item;
  
  m_summary_view->clear();
  
  // The number of columns of the summary view (the top pane) and the header
  // labels for each of the columns are retrieved from the repo.
  QStringList new_cols;
  m_repo->summaryFields(new_cols);
  QStringList::size_type col_count(new_cols.size());
  m_summary_view->header()->
    setDefaultSectionSize((m_summary_view->width() - 4) / col_count);
  m_summary_view->setColumnCount(col_count);
  m_summary_view->setHeaderLabels(new_cols);
  
  // Get SummaryItems from the repository and assemble them into a tree to be
  // displayed in m_summary_view.
  MsgRepo::iterator *iter(m_repo->begin()), *iter_end(m_repo->end());
  int i;
  for (; *iter != *iter_end; ++*iter)
  {
    // see notes.txt for the threading algorithm
    if (!iter->getParentID().isNull())
    {
      if (msgs_by_id.find(iter->getParentID()) == not_found)
      {
        msgs_by_id.insert(iter->getParentID(),
                          new SummaryItem(m_summary_view,
                                          iter->getParentID()));
      }
      entry = msgs_by_id.find(iter->getID());
      if (entry == not_found)
      {
        item = new SummaryItem(*(msgs_by_id.find(iter->getParentID())),
                               iter->getID());
        msgs_by_id.insert(iter->getID(), item);
      }
      else
      {
        item = *entry;
        // NOTE: at this point, item will ALWAYS be a top-level item
        m_summary_view->takeTopLevelItem(
          m_summary_view->indexOfTopLevelItem(item));
        (*(msgs_by_id.find(iter->getParentID())))->addChild(item);
      }
    }
    else
    {
      entry = msgs_by_id.find(iter->getID());
      if (entry == not_found)
      {
        item = new SummaryItem(m_summary_view, iter->getID());
        msgs_by_id.insert(iter->getID(), item);
      }
      else
      {
        item = *entry;
      }
    }
    for (i = 0; i < col_count; ++i)
    {
      item->setText(i, iter->getField(i));
    }
  }
  
  // Restore saved tree view settings for this repository.
  // NOTE: For now, section and key names in configuration won't be i18n-ed.
  // m_summary_view->restoreLayout(Settings::self()->config(),
  //                               m_repo->name() + " List View Settings");
  QString ui_state(m_config.attribute("ui_state"));
  if (!ui_state.isNull())
    m_summary_view->header()->restoreState(
      QByteArray::fromBase64(ui_state.toLocal8Bit()));
  
  // Sort the items in the tree view
  m_summary_view->performSort();
}

MsgRepo *MsgRepoItem::getRepoOfItem() const
{
  // This is used by method(s) of ProgramWindow to get access to the MsgRepo.
  return m_repo;
}
